RegisterAddonMessagePrefix("ZygorLinkTarget")
ZygorLinkTargets = {}

local split = function(string)
	local tab = {}
	for w in string.gmatch(string,"[^\$]+") do
		table.insert(tab,w)
	end
	return unpack(tab)
end

ZygorGuidesViewer:RegisterGuide("Zygor's Achievement Guides\\Exploration\\Pandaria\\Riches of Pandaria(Flying Optimized)",{
condition_end="achieved(7997)",
achieveid={7996,7995,7994},
description="Find all of the Treasures of Pandaria",
},[[
step
label "start"
Enter the ship and go to the bottom floor towards the back to find the Ship's Locker
click Ship's Locker##213362 |goto The Jade Forest 50.8,99.8
Loot from the Ship's Locker |q 31396 |future
step
click Saurok Stone Tablet##213750 |goto Valley of the Four Winds 75.1,55.1
Loot the Saurok Stone Tablet |q 31408 |future
step
click The Hammer of Folly##213845 |goto The Veiled Stair 74.9,76.6
Loot the Hammer of Folly |q 31428 |future
step
click Lucky Pandaren Coin##213368 |goto The Jade Forest 32.0,27.8
Loot the Lucky Pandaren Coin |q 31401 |future
step
click Ancient Pandaren Tea Pot##213366 |goto The Jade Forest 26.2,32.4
Loot the Ancient Pandaren Tea Pot |q 31400 |future
step
click Pandaren Ritual Stone##213748 |goto The Jade Forest 23.5,35.1
Loot the Pandaren Ritual Stone |q 31404 |future
step
click Statue of Xuen##213771 |goto Kun-Lai Summit 72.0,34.0
Loot the Statue of Xuen |q 31416 |future
step
click Ancient Mogu Tablet##214438 |goto Kun-Lai Summit 64.2,45.1
Loot the Ancient Mogu Tablet |q 31420 |future
step
click Stolen Sprite Treasure##213770 |goto Kun-Lai Summit/8 41.4,43.8
Loot from the Stolen Sprite Treasure |q 31415 |future
step
click Rikktik's Tiny Chest##213793 |goto Kun-Lai Summit 52.6,51.5
Loot from Rikktik's Tiny Chest |q 31419 |future
step
click Hozen Treasure Cache##213769 |goto Kun-Lai Summit 50.4,61.8
Loot from the Hozen Treasure Cache |q 31414 |future
step
click Terracotta Head##213782 |goto Kun-Lai Summit/0 59.2,73.0
Loot the Terracotta Head |q 31422 |future
step
click Lost Adventurer's Belongings##213774 |goto Kun-Lai Summit 36.7,79.7
Loot from the Lost Adventurer's Belongings |q 31418 |future
step
click Abandoned Crate of Goods##213961 |goto Townlong Steppes 62.8,34.1
Loot from the Abandoned Crate of Goods |q 31427 |future
step
click Hardened Sap of Kri'vess##213959 |goto Townlong Steppes 52.8,56.2
Loot the Hardened Sap of Kri'vess |q 31424 |future
step
click Fragment of Dread##213956 |goto Townlong Steppes 32.5,60.1
Loot the Fragment of Dread |q 31423 |future
step
click Amber Encased Moth##213844 |goto Townlong Steppes 65.8,86.1
Loot the Amber Encased Moth |q 31426 |future
step
click Virmen Treasure Cache##213650 |goto Valley of the Four Winds 23.7,28.3
Loot from the Virmen Treasure Cache |q 31405 |future
step
Congratulations, you have obtained the Riches of Pandaria achievement! |only if achieved(7997)
Still more treasure required. Routing to the guide start. |next "start" |only if not achieved(7997)
]])

local broadcast = function()
	local guide = ZGV.CurrentGuideName --string.gsub(ZGV.CurrentGuideName,"\\","\\\\")
	local step = ZGV.CurrentStepNum
	for _,target in pairs(ZygorLinkTargets) do
		SendAddonMessage("ZygorLinkTarget",guide.."$"..step,"WHISPER",target)
	end
end

local frame = CreateFrame("Frame")
frame:RegisterEvent("CHAT_MSG_ADDON")
frame:SetScript("OnEvent",
	function(tab,event,prefix,msg,chattype,from)
		if prefix=="ZygorLinkTarget" then
			--print(prefix)
			--print(from)
			--print(ZygorLinkTarget)
			--print(msg)
			if msg=="Link" then
				local alreadylinked=0
				if #ZygorLinkTargets~=0 then
					for _,target in pairs(ZygorLinkTargets) do
						--print(target)
						if from==target then
							alreadylinked=1
						end
					end
				end
				if alreadylinked==0 then
					table.insert(ZygorLinkTargets,from)
				end
				SendAddonMessage("ZygorLinkTarget","Established","WHISPER",from)
			elseif msg=="Established" then
				print(ZygorLinkTarget.." Linked!")
			else
				if from==ZygorLinkTarget then
					local guide,step = split(msg)
					--print(guide.." "..step)

					---[[
					ZGV:SetGuide(guide,step)
					ZGV.pause = true
					--]]

				end
			end
		end
	end
)

local old = ZGV.FocusStep
ZGV.FocusStep = function(num,forcefocus)
	old(num,forcefocus)
	broadcast()
end

SLASH_ZygorLinkSet1 = "/zl"
function ZygorLinkSet()
	if UnitName("target")~=nil and UnitName("target")~=UnitName("player") then
		--print("now")
		local target,tarrealm = UnitName("target")
		local tarrealm = tarrealm or GetRealmName()
		if tarrealm=="" then tarrealm = GetRealmName() end
		ZygorLinkTarget = target.."-"..tarrealm
		print("Attempting to link to "..ZygorLinkTarget.."...")
		SendAddonMessage("ZygorLinkTarget","Link","WHISPER",ZygorLinkTarget)
		--print(ZygorLinkTarget)
		--print("end")
	elseif UnitName("target")==UnitName("player") then
		print("WARNING:Linking yourself is a bad idea. This will set the guide to the step you're already on, and in doing so try to change the step to what you're already on. It will then trigger a response to yourself that you have changed steps causing a never-ending loop that will freeze your WoW client.")
	else
		if ZygorLinkTarget==nil then
			print("No target")
		else
			ZygorLinkTarget=nil
			print("Zygor Link Cleared!")
		end
	end
end
SlashCmdList["ZygorLinkSet"] = ZygorLinkSet
